/*
TASK: circle
LANG: C++
*/

#include <iostream>
#include <vector>
#include <cstdio>
#include <queue>
#include <cmath>
using namespace std;

struct circle
{
 int x,y,r;
 circle() {}
 circle(int a,int b,int c) { x=a; y=b; r=c;}
};

int n,i,j,v=0;
circle inp[1001];
vector<int> A[1001];
int p[1001];
bool used[1001];
queue<int> q;
double d;

double dis(circle &a,circle &b)
{
 return sqrt( (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y) );
}

bool isOk(circle &a,circle &b)
{
  d=dis(a,b);
  if(a.r>b.r) { if(d<a.r) {
                           if(d+b.r<=a.r) return 0;
                           else return 1;
                           }
                else if(d>=a.r+b.r) return 0;
                     else return 1;  
              }
  else  { if(d<b.r) {
                     if(d+a.r<=b.r) return 0;
                     else return 1;
                     }
          else if(d>=a.r+b.r) return 0;
               else return 1;  
        }
}

void init()
{
 scanf("%d",&n);
 for(i=1;i<=n;i++)
   {
    scanf("%d %d %d",&inp[i].x,&inp[i].y,&inp[i].r);
    for(j=1;j<i;j++)
         if(isOk(inp[i],inp[j])) { A[i].push_back(j);
                                   A[j].push_back(i);
                                 }  
    }
 memset(p,-1,sizeof(p));
}

void bfs()
{
 int tmp,to,cur;    
     
 used[1]=1;
 p[1]=0;
 q.push(1);
 v++;
 
 while(v)
 {
  tmp=q.front();
  q.pop();
  v--;
    
  to=A[tmp].size();
  for(i=0;i<to;i++)
     {
      cur=A[tmp][i];
      if(!used[cur]) {used[cur]=1; p[cur]=p[tmp]+1; q.push(cur); v++;}            
     }
 }
}

int main()
{
 init();
 bfs();
 
 printf("%d",p[n]); 
 return 0;
}
