#include <cstdio>
#include <queue>
#include <cmath>

using namespace std;

struct circle
{ int x, y, r; };

int n, answer;
int size[1024];
int A[1024][1024];
circle C[1024];

void bfs(int k)
{
     bool used[1024];
     int at, s;
     queue < int > Q;
     
     memset(used, 0, sizeof(used));
     used[k]=1;
     Q.push(k);
     while(!Q.empty())
     {
         s=Q.size();
         ++answer;
         for (int i=0; i<s; ++i)
         {
             at=Q.front();
             Q.pop();
             for (int i=0; i<size[at]; ++i)
             {
                 int &cache=A[at][i];
                 if (cache == n-1)
                    return;
                 if (!used[cache])
                 {
                     used[cache]=1;
                     Q.push(cache);
                 }
             }
         }
     }
}

void solve()
{
     int d, x, y, r, r1, r2;
     double R1, R2, D;
     
     for (int i=0; i<n; ++i)
         for (int j=0; j<n; ++j)
             if (i != j)
             {
                 x=C[j].x-C[i].x;
                 y=C[j].y-C[i].y;
                 d=x*x+y*y;
                 r1=C[i].r*C[i].r;
                 r2=C[j].r*C[j].r;
                 if (!d) continue;
                 if (d>r1 && d>r2)
                 {
                     r=C[i].r+C[j].r;
                     r*=r;
                     if (d > r)
                        A[i][size[i]++]=j;
                 }
                 else if (d==r1 || d==r2)
                 {
                      if (d==r1 && r1>=r2)
                         A[i][size[i]++]=j;
                      if (d==r1 && r1<r2)
                         if (C[j].r < 2*C[i].r)
                            A[i][size[i]++]=j;
                      if (d==r2 && r1>r2)
                         if (C[i].r < 2*C[j].r)
                            A[i][size[i]++]=j;
                      if (d==r2 && r1<=r2)
                         A[i][size[i]++]=j;
                 }
                 else if ((d<r1 || d<r2) && (r1==r2))
                    A[i][size[i]++]=j;
                 else if (d < r2)
                 {
                     D=sqrt(d);
                     R1=C[i].r;
                     R2=C[j].r;
                     if (r1 < r2)
                     {
                        if (R2 < D+R1)
                           A[i][size[i]++]=j;
                     }
                     else
                        if (R1 < D+R2)
                           A[i][size[i]++]=j;
                 }
                 else
                 {           
                     D=sqrt(d);
                     R1=C[i].r;
                     R2=C[j].r;
                     if (r1 < r2)
                     {
                         if (R2 < D+R1)
                           A[i][size[i]++]=j;
                     }
                     else
                         if (R1 < D+R2)
                            A[i][size[i]++]=j;
                 }
                 
             }
     bfs(0);
     printf("%d\n", answer);
}

void input()
{
     scanf("%d", &n);
     for (int i=0; i<n; ++i)
         scanf("%d%d%d", &C[i].x, &C[i].y, &C[i].r);
}

int main()
{
    input();
    solve();
return 0;
}
