#include <iostream>
#include <stack>

using namespace std;

int det(int x1, int y1, int x2, int y2, int x3, int y3)
{
       return (x1*y2 + x3*y1 + x2*y3 - x3*y2 - x1*y3 - x2*y1);
}

bool check(int x1, int y1, int x2, int y2, int x3, int y3)
{
    if (x1 == x2 || x1 == x3 || x2 == x3
       || y1 == y2 || y1 == y3 || y2 == y3 ) return true;
       
    return false; 
}    

int main()
{   
    int n, i, x1, x2, x3, y1, y2, y3, D, p;
    unsigned sum = 0;
    
    stack<unsigned> st;
    
    scanf("%d", &n);
    
    for (i = 0; i < n; ++i) {
        scanf("%d%d%d%d%d%d", &x1, &y1, &x2, &y2, &x3, &y3);
        D = det(x1, y1, x2, y2, x3, y3);
        if (D < 0) D = -D;
        if (check(x1, y1, x2, y2, x3, y3) && !(D%2)) {
           st.push(D/2);
           sum += st.top();
        }
    }
    char dp[sum + 1];
    for (i = 0; i <= sum; ++i)
        dp[i] = 0;

    dp[0] = 1;
    while (!st.empty()) {
          p = st.top();
          st.pop();
          for (i = sum; i >= 0; --i) {
              if (dp[i]) {
                 if (i == p) {
                    break;
                 }
                 dp[i + p] = 1;
              }
          }
    }

    for (i = sum/2; i >= 0; --i)
        if (dp[i]) {
                   printf("%d %d\n", i, sum - i);
                   break;
        }
    
    return 0;
} 
