#include <stdio.h>
#include <stdlib.h>
#define MAXP 1024
struct _POINT
{
	long x,y;
};
typedef struct _POINT POINT;
int xcmp(const void*,const void*);
int ycmp(const void*,const void*);
long Solve(POINT*,long);
int main()
{
	POINT p[MAXP];
	long n,i;
	scanf("%ld",&n);
	for(i=0;i<n;i++)
	{
		scanf("%ld %ld",&(p[i].x),&(p[i].y));
	}
	i=Solve(p,n);
	printf("%ld %ld\n",i,Solve(p,n-i));
	return 0;
}
int xcmp(const void* a,const void *b)
{
	if(((POINT*)a)->x-((POINT*)b)->x)
		return ((POINT*)a)->x-((POINT*)b)->x;
	return -((POINT*)a)->y+((POINT*)b)->y;
}

int ycmp(const void* a,const void *b)
{
	if(((POINT*)a)->y-((POINT*)b)->y)
		return ((POINT*)a)->y-((POINT*)b)->y;
	return -((POINT*)a)->x+((POINT*)b)->x;
}
long Solve(POINT* x,long n)
{
	long i,j;
	POINT y[MAXP];
	long last,l;
	memcpy(y,x,sizeof(POINT)*n);
	qsort(x,n,sizeof(POINT),xcmp);
	qsort(y,n,sizeof(POINT),ycmp);
	last=bsearch(y,x+n-1,n,sizeof(POINT),ycmp);
	for(i=n-2;i>0;i--)
	{
		l=bsearch(y,x+i,n,sizeof(POINT),ycmp);
		if(l>last)
			break;
		else
			last=l;
	}

	return n-i;
}
