/*
TASK: triangle
LANG: C++
*/

#include <iostream>
#include <vector>
#include <set>
#include <cstdio>

using namespace std;

struct point
{
 int x,y;
 point() {}
 point(int a,int b) {x=a;y=b;}
};

struct comp
{
 bool operator()(int a,int b)
 {return !(a<b);}
};

int n,S,res,i;
long long int sum=0,sum2;
point a,b,c;
vector<int> nums;
set<int,comp> s;
set<int,comp> :: iterator cnt;

int check(point &a,point &b,point &c)
{
 S=(a.x-b.x)*(a.y+b.y)+(b.x-c.x)*(b.y+c.y)+(c.x-a.x)*(c.y+a.y);
 if(S<0) S=-S;
 if(S&1) return -1;
 S/=2;
 
 if(a.x==b.x || a.y==b.y || a.x==c.x || a.y==c.y || b.x==c.x || b.y==c.y) return S;
 else return -1; 
}

void init()
{
 scanf("%d",&n);
 for(i=0;i<n;i++)
    {
     scanf("%d %d %d %d %d %d",&a.x,&a.y,&b.x,&b.y,&c.x,&c.y);
     res=check(a,b,c);
     if(res!=-1) {sum+=res; nums.push_back(res);}    
    }
 sum2=sum;
 sum/=2;
}

int main()
{
 init();
 n=nums.size();
 for(i=0;i<n;i++)
  {  
   cnt=s.begin();
   while(cnt!=s.end())
   {
    if(nums[i]+(*cnt)<=sum)   s.insert(nums[i]+(*cnt));
    cnt++;
    }     
   if(nums[i]<=sum)  s.insert(nums[i]);
  }
 
 long long int firs=*(s.begin()); 
 cout<<firs<<" "<<sum2-firs<<endl;

 return 0;
}
