#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
#include <set>
#include <cmath>
#define ii pair<int, int>
#define i3 pair<ii, int>
using namespace std;

int main()
{
    int n,i;
    vector<int> G[1024];
    scanf("%d", &n);
    int x,y,r;
    scanf("%d %d %d", &x, &y, &r);
    vector<i3> circ;
    circ.push_back(i3(ii(x,y), r));
    int j;
    bool ok;
    for(i=1;i<n;i++)
    {
     scanf("%d %d %d", &x, &y, &r);
     ok=false;
     for(j=0;j<circ.size();j++)
     {
      ii curr=circ[j].first;
      int dist = (int) sqrt(abs(x-curr.first)*abs(x-curr.first) +
                                               abs(y-curr.second)*abs(y-curr.second));

      if(r+circ[j].second > dist && dist+min(r,circ[j].second) > max(r,circ[j].second))
      {
        ok=true;
        G[i].push_back(j);
        G[j].push_back(i);
      }
     }
     if(ok)
      circ.push_back(i3(ii(x,y), r));
    }
    
    queue<ii> q;
    q.push(ii(0,0));
    vector<bool> used(n, false);
    bool f=false;
    
    while(!q.empty() && !f)
    {
     ii curr=q.front();
     q.pop();
     used[curr.first]=true;     
     for(i=0;i<G[curr.first].size();i++)
     {
      if(!used[G[curr.first][i]])
      {
       q.push(ii(G[curr.first][i], curr.second+1));
       if(G[curr.first][i] == n-1)
       {
        f=true;
        printf("%d\n", curr.second+1);
        break;
       }
      }
     }
    }
    
    if(!f)
     printf("%d\n", -1);
        
    return 0;
}
