/*
  Name: triangle
  Author: Nikola Taushanov
  Description: Triygylnici
*/

#include <iostream>
#define MAXU 6
#define MAXS 1000
using namespace std;

int k=0, u[MAXU], s[MAXS], sp[MAXS], s1max, s2max, rmax = 100000;

void difr()
{
     int s1=0,s2=0;
     for(int sth=0; sth<k; sth++)
     {
             for(int i=0; i<k-1; i=i+2)
                if(i <= sth) s1 = s[i]+s[i+1];
                 else s2 = s[i]+s[i+1];
             if(abs(s1-s2) < rmax)
             {
                   s1max = s1;
                   s2max = s2;
                   rmax = abs(s1-s2);
             }
             s1=0;
             s2=0;
     }
     return;
}

void permute(int i)
{
            if(i>=k)
            {
                    difr(); 
                    return;
            }
            for(int j=0;j<k;j++)
            if(!u[j])
            {
                        u[j]=1;
                        s[i]=sp[j];
                        permute(i+1);
                        u[j]=0;
            }
}                        

int issint(double s)
{
     if(s - (int)s == 0.0000000)return 1;
     else return 0;
}

double usp(int a1, int a, int b1, int b, int c1, int c)
{
    double result = 0;
    if(a == b) result = abs(a1-b1)*abs(c-a);
    else if(a == c) result = abs(a1-c1)*abs(b-a);
    else if(b == c) result = abs(c1-b1)*abs(a-b);
    else if(a1 == b1) result = abs(a-b)*abs(c1-a1);
    else if(a1 == c1) result = abs(a-c)*abs(b1-a1);
    else if(b1 == c1) result = abs(c-b)*abs(a1-b1);  
    result = result/2;
    if(issint(result)) return result; else return 0;
}

int main()
{
     int n,a,a1,b,b1,c,c1;
     cin >> n;
     
     for(int i=0; i<n; i++)
     {
             cin >> a >> a1 >> b >> b1 >> c >> c1;
             double m = usp(a, a1, b, b1, c, c1);
             if(m)
             {
                   sp[k]=m; 
                   k++;
             }
     }
     
     for(int i=0; i<k; i++)
      u[i] = 0;
      
     permute(0);
     
     if(s1max >= s2max) swap(s1max, s2max);
     cout << s1max << " " << s2max; 

     return 0;    
}
