#include <cstdio>
#include <algorithm>

using namespace std;

struct point
{
    int x, y;
    bool operator< (const point &b) const
    {
         if (x != b.x)
            return x < b.x;
         else
            return y < b.y;
    }
};

bool found;
int n, opti, subopti, Y, size;
point A[1<<19], B[1<<19];

void solve()
{
     sort(A, A+n);
     for (int i=0; i<n-1; ++i)
     {
         if (!found)
         {
            if (A[i].y == Y)
            {
                found=1;
                ++opti;
            }
            else
            {
                B[size].x=A[i].x;
                B[size++].y=A[i].y;
            }
         }
         else
         {
             if (A[i].y<=Y && A[i].x<A[i+1].x)
                 ++opti;
             else
             {
                 B[size].x=A[i].x;
                 B[size++].y=A[i].y;
             }
         }
     }
     if (A[n-1].x != A[n-2].x)
         ++opti;
     else
     {
         B[size].x=A[n-1].x;
         B[size++].y=A[n-1].y;
     }
     found=0;
     Y=0;
     for (int i=0; i<size; ++i)
         if (B[i].y > Y)
            Y=B[i].y;
     for (int i=0; i<size-1; ++i)
     {
         if (!found)
         {
              if (B[i].y == Y)
              {
                  found=1;
                  ++subopti;
              }
         }
         else
             if (B[i].y<=Y && B[i].x<B[i+1].x)
                ++subopti;
     }
     if (B[size-1].x != B[size-2].x)
        ++subopti;
     printf("%d %d\n", opti, subopti);
}

void input()
{
     scanf("%d", &n);
     for (int i=0; i<n; ++i)
     {
         scanf("%d%d", &A[i].x, &A[i].y);
         if (A[i].y > Y)
            Y=A[i].y;
     }
}

int main()
{
    input();
    solve();
return 0;
}
