#include <stdio.h>
#define MAXN 1024
using namespace std;
typedef struct
{
        short x, y;
        unsigned short r;
} circle;
circle okr[MAXN];
unsigned short n, depth[MAXN], queue[MAXN];
bool used[MAXN];
/**/unsigned short sqr(short a)
{
             return a*a;
}
bool cross(circle a, circle b)
{
     if(sqr(a.x - b.x) + sqr(a.y - b.y) < sqr(a.r) || sqr(a.x - b.x) + sqr(a.y - b.y) < sqr(b.r))
     {
         if(sqr(a.x - b.x) + sqr(a.y - b.y) > sqr(a.r - b.r))
                    return true;
         else return false;
     }
     else
     {
         if(sqr(a.x - b.x) + sqr(a.y - b.y) < sqr(a.r + b.r))
                    return true;
         else return false;
     }
}
/**/void read_data()
{
     scanf("%d", &n);
     for(int i = 1; i <= n; ++i)
     {
             scanf("%d %d %d", &okr[i].x, &okr[i].y, &okr[i].r);
     }
}
/**/void BFS()
{
     unsigned short start = 0, end = 0;
     depth[1] = 0;
     queue[0] = 1;
     used[1] = true;
     while(start <= end && !used[n+1])
     {
                 for(int i = 1; i <= n; ++i)
                 {
                         if(cross(okr[i], okr[queue[start]]) && !used[i])
                         {
                                          used[i] = true;
                                          depth[i] = depth[queue[start]]+1;
                                          ++end;
                                          queue[end] = i;
                         }
                 }
                 ++start;
     }
}
/**/int main()
{
    read_data();
    BFS();
    if(depth[n] == 0)
    {
                  printf("%d\n", -1);
                  return 0;
    }
    printf("%d\n", depth[n]);
    return 0;
}
