#include <cstdio>
#include <cmath>
#include <iostream>


struct point {
	int x, y;
	
	point(){}
	point(int _x, int _y) : x(_x), y(_y) {}
};

struct triangle {
	point a, b, c;
	
	double s() {
		return fabs(a.x*(b.y + c.y) + b.x*(a.y + c.y) + c.x*(a.y + b.y))/2;
	}
	
	triangle(){}
	triangle(point _a, point _b, point _c) : a(_a), b(_b), c(_c) {}
};

int n;
triangle tr;
int s[1024];
int l, dl;
double hk, md;
int k;
int a;
bool used[1 << 15];
int dyn[1 << 22];

bool usp(triangle tr) {
	return (tr.a.x == tr.b.x || tr.a.x == tr.c.x || tr.b.x == tr.c.x || tr.a.y == tr.b.y || tr.a.y == tr.c.y || tr.b.y == tr.c.y);
}

bool isint(double x) {
	return (x - (int)x) < 0.0001;
}

bool good(triangle tr) {
	bool gf = isint(tr.s());
	return (usp(tr) && gf);
}

int min(int a, int b) {
	return a < b ? a : b;
}

int max(int a, int b) {
	return a > b ? a : b;
}

void rec(int x) {
	if(a + s[x] <= hk) {
		a += s[x];
		if(md > hk - a) {
			md = hk - a;
			if(a == (int)hk) {
				printf("%d %d\n", a, k - a);
				exit(0);
			}
		}
	}
	
	for(int i = x + 1; i < l; ++i) {
		rec(i);
	}
	a -= s[x];
}

int main() {
	scanf("%d", &n);
	
	
	for(int i = 0; i < n; ++i) {
		scanf("%d%d%d%d%d%d", &tr.a.x, &tr.a.y, &tr.b.x, &tr.b.y, &tr.c.x, &tr.c.y);

		if(good(tr)) {
			s[l++] = (int)tr.s();
			k += s[l-1];
		}
	}
	if(n == 2) {
		printf("%d, %d\n", min(s[0], s[1]), max(s[0], s[1]));
		return 0;
	}
	
	hk = (double)k/2;
	
	for(int i = 0; i < l; ++i) {
		rec(i);
	}
	
	a = (int)(hk + md);
	
	printf("%d %d\n", a, k - a);
	
	return 0;
}
