//pareto.cpp
#include <stdio.h>
#include <stdlib.h>

#define MAXN (1 << 20)
int n, x[MAXN], y[MAXN], s[MAXN], ss[MAXN], nn;

int cmp(const void *pa, const void *pb){
  int a = *(int*)pa, b = *(int*)pb;
  if(x[a] < x[b]) return -1;
  if(x[a] > x[b]) return 1;
  if(y[a] < y[b]) return -1;
  if(y[a] > y[b]) return 1;
  return 0;    
}

bool opt[MAXN];
int pareto(void){
  int i, m, r;
  qsort(s, n, sizeof(int), cmp);
  i = n-1;
  opt[s[i]] = true;
  m = y[s[i]];
  i--;
  r = 1;
  while(i >= 0){
    if(y[s[i]] > m){
      m = y[s[i]];
      opt[s[i]] = true;
      r++;         
    } 
    i--;   
  }
  return r;
}

int main(){
  int i, ro, roo;
  scanf("%d", &n);
  for(i = 0; i < n; i++){
    scanf("%d %d", x+i, y+i);
    s[i] = i;
    opt[i] = false;
  }
  ro = pareto();
  
  //now remove the optimal 
  nn = 0;
  for(i = 0; i < n; i++)
    if(!opt[s[i]]){
      ss[nn] = s[i];
      nn++;
    }
  for(i = 0; i < nn; i++)
    s[i] = ss[i];
  n = nn;
  roo = pareto();
  printf("%d %d\n", ro, roo);
  return 0;    
}
