
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>
#define MAXN 1024
int g[MAXN][MAXN];
struct _CIR
{
	long x,y,r;
};
typedef struct _CIR CIR;
inline char IsEdge(CIR,CIR);//prowerqwa ima li rebro m/u 2te okryzhnosti
void GetCir(CIR*,int*);//priema whoda
void MakeGraph(CIR*,int,int*);//ot okryzhnostite prawi graf
int bfs(int,int*);

int main()
{
	CIR c[MAXN];
	int n;
	int gn[MAXN];
	GetCir(c,&n);
	memset(gn,0,sizeof(int)*n);
	MakeGraph(c,n,gn);
	printf("%d\n",bfs(n,gn));
	return 0;
}
inline char IsEdge(CIR a,CIR b)
{
	long d=((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
	return ((d<(a.r+b.r)*(a.r+b.r))&&d>abs(a.r-b.r)*abs(a.r-b.r));
}
void GetCir(CIR* c,int* n)
{
	int i;
	scanf("%d",n);
	for(i=0;i<*n;i++)
		scanf("%ld%ld%ld",&(c[i].x),&(c[i].y),&(c[i].r));
}
void MakeGraph(CIR*c,int n,int* gn)
{
	int i,j;
	for(i=0;i<n;i++)
		for(j=i+1;j<n;j++)
			if(IsEdge(c[i],c[j]))
			{
				g[i][gn[i]++]=j;
				g[j][gn[j]++]=i;
			}
}
int bfs(int n,int *gn)
{
	int q[MAXN];
	int qs,qe;
	int p[MAXN];
	int i;
	int cu;
	memset(p,~0,sizeof(int)*n);
	qs=0;
	qe=1;
	q[0]=0;
	p[0]=0;
	while(qs<qe)
	{
		cu=q[qs];
		for(i=0;i<gn[cu];i++)
			if(p[g[cu][i]]==-1)
			{
				q[qe++]=g[cu][i];
				p[g[cu][i]]=p[cu]+1;
				if(g[cu][i]==n-1)
					goto end;
			}
		qs++;
	}
end:
	return p[n-1];
}
