#include <cmath>
#include <cstdio>
#include <queue>

using namespace std;

double h;
int n,a[1024][1024],x[1024],y[1024],r[1024],p[1024];
queue <int> q;

void fspt ();

int main ()
{
	scanf ("%d",&n);
	int i,j;
	for (i=0;i<n;i++)
	{
		scanf ("%d %d %d",&x[i],&y[i],&r[i]);
		if (r[i]<0) r[i]*=-1;
	}
	for (i=0;i<n;i++)
	{
		for (j=0;j<n;j++)
		{
			h=sqrt ((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]));
			a[i][j]=0;
			if (i!=j && r[i]+r[j]>h && r[i]-r[j]<h && r[j]-r[i]<h)
				a[i][j]=1;
		}
		p[i]=-1;
	}
	fspt ();
	printf ("%d\n",p[n-1]);
	return 0;
}

void fspt ()
{
	int l=0,f,i;
	q.push (0);
	q.push (-1);
	do
	{
		f=q.front ();
		q.pop ();
		if (f==-1)
		{
			l++;
			q.push (-1);
			f=q.front ();
			q.pop ();
		}
		for (i=0;i<n;i++)
		{
			if (a[i][f] && p[i]<0)
			{
				q.push (i);
				p[i]=l+1;
			}
		}
	} while (p[n-1]<0 && q.size ()>1);
}
