#include <iostream>
#include <math.h>
using namespace std;

int N;
int A[1024][3];
int B[1024][1024];

inline int sqr(int x) {return x*x;}

bool pres(int i,int j)
{
     double dist = sqrt(sqr(A[i][0]-A[j][0])+sqr(A[i][1]-A[j][1]));
     if(dist<max(A[i][2],A[j][2])) {
          if(A[i][2]<A[j][2]) {i^=j^=i^=j;}
          return dist+A[j][2]>A[i][2];
     }
     else
     {
         return A[i][2]+A[j][2]>dist;
     }
}

int main(){
    cin>>N;
    for(int i=0; i<N; i++)
    {
            cin>>A[i][0]>>A[i][1]>>A[i][2];
    }
    for(int i=0; i<N; i++)
    {
            for(int j=0; j<N; j++)
            {
                    if(i==j) {B[i][j] = 0; continue;}
                    B[i][j] = pres(i,j);
            }
    }
    for(int i=0; i<N; i++)
    {
            for(int j=0; j<N; j++)
            {
                    cout<<B[i][j]<<" ";
                    if(B[i][j]==0) {B[i][j] = 10000;}
            }
            cout<<endl;
    }
    for(int i=0; i<N; i++) {B[i][i] = 0;}
    for(int i=0; i<N; i++)
    {
            for(int j=0; j<N; j++)
            {
                    for(int k=0; k<N; k++)
                    {
                            if(B[j][i]+B[i][k]<B[j][k]) {B[j][k] = B[j][i]+B[i][k];}
                    }
            }
    }
    if(B[0][N-1]==10000) {cout<<"-1\n"; return 0;}
    cout<<B[0][N-1]<<"\n";
    return 0;
}
